<?php
################################################################################
# ffa4minibb <http://geni.ath.cx/ffa4minibb.html>
# Free File Attachment for miniBB <http://minibb.net>
# (C) 2007-2009 GPL by Huidae Cho <http://geni.ath.cx>
################################################################################
# Version 0.3 (2009-04-13)
# - Suppress the error message when the user fails to login.
#
# Version 0.2 (2008-04-05)
# - Fixed the bug that prints out invalid URLs when filenames include spaces.
#
# Version 0.1 (2007-07-05)
# - First release
################################################################################
# Added file:
#	ffa4minibb.php
# Affected files:
#	bb_plugins.php
#	bb_plugins2.php
#	bb_default_style.css
#	templates/main_post_form.html
#	templates/main_posts_cell.html
#	templates/main_post_area.html
#	templates/main_topics.html
#	templates/tools_edit_post.html
################################################################################
# Installation:
#
# 1. Copy ffa4minibb.php to the root directory of your miniBB.
#
# 2. Add the following line to bb_plugins.php:
#
#	require_once("ffa4minibb.php");
#
# 3. Add the following line to bb_plugins2.php:
#
#	if(function_exists("ffa_plugin2")) ffa_plugin2();
#
# 4. Add the following to bb_default_style.css:
#
#	.fileAttachment {
#		background-color:	#ffffff;
#		border:			1px solid #dddddd;
#		padding:		3px;
#	}
#
# 5. Find {$emailCheckBox} in templates/main_post_form.html and add the
# following line *above* this line:
#
#	{$fileAttachment}
#
# 6. Find {$posterText} in templates/main_posts_cell.html and add the following
# line *below* this line:
#
#	{$fileAttachment}
#
# 7. Find a <form tag from templates/main_post_area.html,
# templates/main_topics.html, and templates/tools_edit_post.html and add the
# following attribute:
#
#	enctype="multipart/form-data"
#
# 8. Make sure the root directory of miniBB is writable by www/nobody or create
# the files directory and chmod it properly:
#
#	mkdir files
#	chmod 755 files or chmod 1757 files
#
# 9. OPTIONAL: You can use the $ffa_[] array to customize ffa4minibb. See the
# user settings section for available variables. For example, if you want to
# change the maximum number of file attachments, add the following line to your
# language file:
#
#	$ffa_['maxNumFiles'] = 5;
################################################################################
if(defined('FFA4MINIBB')) return; define('FFA4MINIBB', 1);

################################################################################
# user settings
ffa_config('allowedFiles', '\.(png|gif|jpg|jpeg|txt|zip)$');
ffa_config('attachmentDir', 'files');
ffa_config('dirMode', 0755);
ffa_config('fileMode', 0644);
ffa_config('maxNumFiles', 10);
ffa_config('allowedFileTypes', str_replace('\.(', '.', str_replace(')$', '',
	str_replace('|', ', .', $ffa_['allowedFiles']))));
ffa_config('notAllowedFileMsg', 'This file type is not allowed. Please upload '.
	"$ffa_[allowedFileTypes].");
ffa_config('numFilesMsg', 'File attachment: %s file(s), '.
	"max $ffa_[maxNumFiles] files, ($ffa_[allowedFileTypes])");
ffa_config('attachedFileMsg', 'Attached file:');
ffa_config('attachedFilesMsg', 'Attached files:');
ffa_config('deleteFileMsg', 'Delete attached file:');
ffa_config('deleteFilesMsg', 'Delete attached files:');
# end of user settings
################################################################################

# called by bb_plugins.php
ffa_plugin();

################################################################################
function ffa_plugin(){
	switch($GLOBALS['action']){
	case 'vtopic':
	case 'vthread':
		function parseMessage(){
			$GLOBALS['fileAttachment'] =
				ffa_list($GLOBALS['cols'][6]);
		}
		$GLOBALS['fileAttachment'] = ffa_upload_form();
		break;
	case 'editmsg':
		$GLOBALS['fileAttachment'] = ffa_list($_GET['post'], 1);
		break;
	}
	return;
}

function ffa_plugin2(){
	switch($GLOBALS['action']){
	case 'ptopic':
	case 'pthread':
		if(isset($GLOBALS['inss']) && $GLOBALS['inss'] == 0)
			ffa_upload($GLOBALS['topic_last_post_id']);
		break;
	case 'editmsg2':
		if(isset($GLOBALS['fif']))
			ffa_edit($GLOBALS['post']);
		break;
	case 'deltopic':
		ffa_delete_topic($GLOBALS['topic']);
		break;
	case 'delmsg':
		foreach($GLOBALS['deleteAll'] as $post)
			ffa_delete($post);
		break;
	}
}

################################################################################
function ffa_config($var, $val){
	if(!isset($GLOBALS['ffa_'][$var]))
		$GLOBALS['ffa_'][$var] = $val;
}

function ffa_upload_form(){
	global $ffa_;

	return
'<!-- Free File Attachment for miniBB by Huidae Cho '.
'http://geni.ath.cx/ffa4minibb.html -->
'.sprintf($ffa_['numFilesMsg'],
	'<input class="inputButton" style="text-align:right;" size="2" '.
	'value="1" onkeyup="ffa_numFiles(this.value)" />').'
<div id="fileAttachment">
<input class="inputButton" type="file" id="file[0]" name="file[0]" '.
'onchange="ffa_fileCheck(this)" /><br id="file_br[0]" />
</div>
'.<<<EOT
<script type="text/javascript">
//<![CDATA[
function ffa_numFiles(numFiles){
	if(!numFiles.match(/^[0-9]+$/))
		return;
	if(numFiles > $ffa_[maxNumFiles])
		numFiles = $ffa_[maxNumFiles];

	var fileAttachment = document.getElementById('fileAttachment');
	var obj;

	for(var i = 0; i < numFiles; ++i){
		if(document.getElementById('file['+i+']'))
			continue;
		obj = document.createElement('input');
		obj.setAttribute('class', 'inputButton');
		obj.setAttribute('className', 'inputButton'); // IE workaround
		obj.setAttribute('type', 'file');
		obj.setAttribute('id', 'file['+i+']');
		obj.setAttribute('name', 'file['+i+']');
		obj.setAttribute('onchange', 'ffa_fileCheck(this)');
		fileAttachment.appendChild(obj);

		obj = document.createElement('br');
		obj.setAttribute('id', 'file_br['+i+']');
		fileAttachment.appendChild(obj);
	}

	for(; i < $ffa_[maxNumFiles]; ++i){
		obj = document.getElementById('file['+i+']');
		if(!obj)
			break;
		fileAttachment.removeChild(obj);

		obj = document.getElementById('file_br['+i+']');
		fileAttachment.removeChild(obj);
	}

	return;
}

function ffa_fileCheck(fileName){
	if(!fileName.value.match(/$ffa_[allowedFiles]/i)){
		alert('$ffa_[notAllowedFileMsg]');
		fileName.value = '';
	}

	return;
}
//]]>
</script>
EOT
.'
<!-- End of File Attachment -->';
}

function ffa_list($post, $edit = 0){
	global $ffa_;

	$dir = "$ffa_[attachmentDir]/$post";
	if(file_exists($dir)){
		$dh = opendir($dir);
		while(($file = readdir($dh)) !== false){
			if(!is_file("$dir/$file"))
				continue;
			$files[] = $file;
		}
		closedir($dh);
	}

	$ret = "";
	if(isset($files)){
		sort($files);
		$n = 0;
		foreach($files as $file){
			$url = rawurlencode($file);
			$ret .= ($edit ?
				"<input type=\"checkbox\" id=\"file[$n]\" ".
				"name=\"file[$n]\" value=\"$url\" />"
				:
				"").
				"<a href=\"$dir/$url\">$file</a><br />\n";
			++$n;
		}
		if($n)
			$ret = ($edit ?
				"<div>\n".($n > 1 ?
					$ffa_['deleteFilesMsg'] :
					$ffa_['deleteFileMsg'])
				:
				"<div class=\"fileAttachment\">\n".($n > 1 ?
					$ffa_['attachedFilesMsg'] :
					$ffa_['attachedFileMsg'])
				)."<br />\n$ret\n</div>";
	}
	if($edit)
		$ret .= ffa_upload_form();

	return $ret;
}

function ffa_delete($post, $files = ""){
	global $ffa_;

	$dir = "$ffa_[attachmentDir]/$post";
	if(!file_exists($dir))
		return;

	if($files == ""){
		$dh = opendir($dir);
		while(($file = readdir($dh)) !== false){
			if(!is_file("$dir/$file"))
				continue;
			unlink("$dir/$file");
		}
		closedir($dh);
	}elseif(is_array($files)){
		foreach($files as $file){
			if(!is_file("$dir/$file"))
				continue;
			unlink("$dir/$file");
		}
	}elseif(is_file("$dir/$files"))
		unlink("$dir/$files");

	@rmdir($dir);

	return;
}

function ffa_delete_topic($topic){
	if(!($row = db_simpleSelect(0, $GLOBALS['Tp'], 'post_id',
		'topic_id', '=', $topic)))
		return;
	do ffa_delete($row[0]); while(($row = db_simpleSelect(1)));

	return;
}

function ffa_upload($post){
	global $ffa_;

	$dir = "$ffa_[attachmentDir]/$post";
	$files = $_FILES['file'];
	$n = count($files['tmp_name']);
	for($i=0; $i<$n; ++$i){
		$tmp_name = $files['tmp_name'][$i];
		$name = $files['name'][$i];
		if(get_magic_quotes_gpc() == 1)
			$name = stripslashes($name);
		if($tmp_name == "" || !is_uploaded_file($tmp_name) ||
			!preg_match("/$ffa_[allowedFiles]/i", $name))
			continue;
		if(!file_exists($dir)){
			if(!file_exists($ffa_['attachmentDir']))
				mkdir($ffa_['attachmentDir'],
					$ffa_['dirMode']);
			mkdir($dir, $ffa_['dirMode']);
		}
		$name = "$dir/$name";
		move_uploaded_file($tmp_name, $name);
		chmod($name, $ffa_['fileMode']);
	}

	return;
}

function ffa_edit($post){
	if(isset($_POST['file'])){
		foreach($_POST['file'] as $i => $file)
			$files[] = $file;
		ffa_delete($post, $files);
	}
	ffa_upload($post);

	return;
}
?>
